//+------------------------------------------------------------------+
//|                                            FXA0 - 10points 3.mq4 |
//|                              Copyright  2007, Adam Richter M.S. |
//|                                         http://www.forex-tsd.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Adam Richter M.S."
#property link      "http://www.forex-tsd.com"
/*
Thanks to Alejandro Galindo of http://elCactus.com for the original 10points3 code
7/7/2007 - Removed date protection, added magic number for easier order identification,
removed reverse condition because added direction function, changed maxtrades to 7 default to
avoid fequent margin calls.

Thanks to davidke20 added Standards, Minies, NANO, StopNReverse, 
PipValue, OrderstoProtect, Added time filter as interval besides pipstep. 
Settings is in milliseconds.

Added entry and exit function criteria
	 
*/ 

extern double TakeProfit = 40;
extern double Lots = 0.1;
extern double InitialStop = 0;
extern double TrailingStop = 20;

extern int MaxTrades=7;
extern int Pips=15;
extern int SecureProfit=10;
extern int AccountProtection=1;
extern int OrderstoProtect=3;
extern int mm=0;
extern int risk=12;
extern int AccountType=0; //0 for 1 decimal place standard account|| 1 for 2 decimal places standard or mini account
                          //2 for NANO account, IBFX only
extern int Magic = 88888; //added
extern bool StopNReverse=false;
extern bool Use_time_interval=false;
extern int SleepTime=3600000;  //this is one hour divide by 1000 and is seconds
datetime LastOrderTime;

int  OpenOrders=0, cnt=0;
int  slippage=5;
double sl=0, tp=0;
double BuyPrice=0, SellPrice=0;
double lotsi=0, mylotsi=0;
int mode=0, myOrderType=0;
bool ContinueOpening=True;
double LastPrice=0;
int  PreviousOpenOrders=0;
double Profit=0;
int LastTicket=0, LastType=0;
double LastClosePrice=0, LastLots=0;
double Pivot=0;
double PipValue=0;
string text="", text2="";

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//---- 
   //determines what size lots to use, if mm=0 then will use lot size above
   if (AccountType==0)
   { //standard account
	 if (mm!=0) { lotsi=MathCeil(AccountBalance()*risk/10000); }
	 else { lotsi=Lots; }
   } 
   if (AccountType==1)
   {  // then is mini
    if (mm!=0) { lotsi=MathCeil(AccountBalance()*risk/10000)/10; }
	 else { lotsi=Lots; }
   }
   if (AccountType==2)
   { // micro nano lot - IBFX only
    if (mm!=0) { lotsi=MathCeil(AccountBalance()*risk/10000)/100; }
    else { lotsi=Lots; }
   }   
   if (lotsi>100){ lotsi=100; } //if lots greater than 100 defaults to 100

   
   OpenOrders=0; //finds total number of open orders
   for(cnt=0;cnt<OrdersTotal();cnt++)   
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) { OpenOrders++; }
   }  
   
   PipValue=MarketInfo(Symbol(),16);
   if (PipValue==0) { PipValue=1; }
   
   ////if an order was manually closed, or closed with profit this will close all orders
   if (PreviousOpenOrders>OpenOrders) 
   {	  
	  for(cnt=OrdersTotal();cnt>=0;cnt--)
	  {
	     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  	  mode=OrderType();
		  if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
		  {
			if (mode==OP_BUY) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage,Blue); }
			if (mode==OP_SELL) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage,Red); }
			return(0);
		 }
	  }
   }
   
   ////this tests if the maximum number of orders are open
   PreviousOpenOrders=OpenOrders;
   if (OpenOrders>=MaxTrades) 
   {
	  ContinueOpening=False;
   } else {
	  ContinueOpening=True;
   }
   
   ////this sets the lastprice of the order opened and whether the last order was a buy 2 or sell 1
   if (LastPrice==0) 
   {
	  for(cnt=0;cnt<OrdersTotal();cnt++)
	  {	
	    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
		 mode=OrderType();	
		 if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
		 {
			LastPrice=OrderOpenPrice();
			if (mode==OP_BUY) { myOrderType=2; }
			if (mode==OP_SELL) { myOrderType=1;	}
		 }
	  }
   }
   ////if there are no open orders check for entry direction and set direction to buy/sell
   if (OpenOrders<1) 
   {
	  myOrderType=entryDirection();
   }

   //// if we have opened positions and trailing stop, update them  
   for(cnt=OrdersTotal();cnt>=0;cnt--)
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol() == Symbol() && OrderMagicNumber()==Magic) 
	  {	
	  	  if (OrderType()==OP_SELL) 
	  	  {			
	  	  	  if (TrailingStop>0 && (OrderOpenPrice()-Ask>=(TrailingStop+Pips)*Point) && (OrderStopLoss()>(Ask+Point*TrailingStop))) 
			  {							
				 OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderClosePrice()-TakeProfit*Point-TrailingStop*Point,800,Purple);
				 
				 //not sure if this return should be here if it is udpating all trailing stops
	  		    return(0);	  					
			  }
	  	  }
	  	  if (OrderType()==OP_BUY)
	  	  {
	  		 if (TrailingStop>0 && (Bid-OrderOpenPrice()>=(TrailingStop+Pips)*Point) && (OrderStopLoss()<(Bid-Point*TrailingStop))) 
	  		 {				   
			   OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderClosePrice()+TakeProfit*Point+TrailingStop*Point,800,Yellow);
            return(0);
			 }
	  	  }
   	}
   }
   
   ////finds current profit on last opened order and closes it if profitable
   Profit=0; LastTicket=0; LastType=0; LastClosePrice=0;	LastLots=0; LastOrderTime=NULL;	
	for(cnt=0;cnt<OrdersTotal();cnt++)
	{
	  OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
	  {			
	  	   LastTicket=OrderTicket();
			if (OrderType()==OP_BUY) { LastType=OP_BUY; }
			if (OrderType()==OP_SELL) { LastType=OP_SELL; }
			LastClosePrice=OrderClosePrice();
			LastLots=OrderLots();
			LastOrderTime=OrderOpenTime();
			if (LastType==OP_BUY) 
			{			
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit-(OrderOpenPrice()-OrderClosePrice())*OrderLots()/Point; }
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit+(OrderClosePrice()-OrderOpenPrice())*OrderLots()/Point; }
			}
			if (LastType==OP_SELL) 
			{
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit-(OrderClosePrice()-OrderOpenPrice())*OrderLots()/Point; }
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit+(OrderOpenPrice()-OrderClosePrice())*OrderLots()/Point; }
			}
	  }
   }
   
	////This is the protection and close code
	Profit=Profit*PipValue;
	text2="Profit: $"+DoubleToStr(Profit,2)+" +/-";
   if (OpenOrders>=(MaxTrades-OrderstoProtect) && AccountProtection==1) 
   {	    
	     ////this closes the last order if it is profitable, which means all orders will be closed on next interation
	     if (Profit>=SecureProfit) 
	     {
	        OrderClose(LastTicket,LastLots,LastClosePrice,slippage,Yellow);		 
	        ContinueOpening=False;
	        return(0);
	     }
	     ////close if going in wrong direction of buy according to auditTrade function
		  if (LastType==OP_BUY)
		  {
		     if(auditTrade()==1)
		     {
               OrderClose(LastTicket,LastLots,Bid,slippage,Yellow); //close last order at market
               ContinueOpening=False;
               return(0);
		         //close last long trade
		     }
		  }
		  
		  ////close if going in wrong direction of sell according to auditTrade function
		  if (LastType==OP_SELL) 
		  {
		    if(auditTrade()==2)
		    {
               OrderClose(LastTicket,LastLots,Ask,slippage,Yellow); //closes last order at market		 
               ContinueOpening=False;
               return(0);
		         //close last short trade
		    }
		  }
   }

      if (!IsTesting()) 
      {
	     if (myOrderType==3) { text="No conditions to open trades"; }
	     else { text="                         "; }
	     Comment("LastPrice=",LastPrice," Previous open orders=",PreviousOpenOrders,"\nContinue opening=",ContinueOpening," OrderType=",myOrderType,"\n",text2,"\nLots=",lotsi,"\n",text);
      }
      
      //Added stop and reverse
      if(StopNReverse)
      {
         int MyCurrentType=entryDirection();
         if(myOrderType!=MyCurrentType && OpenOrders>=OrderstoProtect)
         {OpenOrders=OpenOrders-1;
          ContinueOpening=false;
         }
      }

      if (myOrderType==1 && ContinueOpening) // && TimeCurrent()>(LastOrderTime + SleepTime)
      {	
	     if ((Bid-LastPrice)>=Pips*Point || OpenOrders<1) 
	     {		
		    SellPrice=Bid;				
		    LastPrice=0;
		    if (TakeProfit==0) { tp=0; }
		    else { tp=SellPrice-TakeProfit*Point; }	
		    if (InitialStop==0) { sl=0; }
		    //// else { sl=NormalizeDouble(SellPrice+InitialStop*Point + (MaxTrades-OpenOrders)*Pips*Point, Digits);  } //trailing stop by tururo
		    else { sl=SellPrice+InitialStop*Point;  }
		    if (OpenOrders!=0) 
		    {
			      mylotsi=lotsi;			
			      for(cnt=1;cnt<=OpenOrders;cnt++)
			      {
				     if (MaxTrades>12) { mylotsi=NormalizeDouble(mylotsi*1.5,2); }
				     else { mylotsi=NormalizeDouble(mylotsi*2,2); }
			      }
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    OrderSend(Symbol(),OP_SELL,mylotsi,SellPrice,slippage,sl,tp,"10points3 Buy Order",Magic,0,Red);		    		    
		    return(0);
	     }
	     ////if(Use_time_interval){Sleep(SleepTime);}
      }
      
      if (myOrderType==2 && ContinueOpening) //&& TimeCurrent()>(LastOrderTime + SleepTime) 
      {
	     if ((LastPrice-Ask)>=Pips*Point || OpenOrders<1) 
	     {		
		    BuyPrice=Ask;
		    LastPrice=0;
		    if (TakeProfit==0) { tp=0; }
		    else { tp=BuyPrice+TakeProfit*Point; }	
		    if (InitialStop==0)  { sl=0; }
		    //////else { sl=NormalizeDouble(BuyPrice-InitialStop*Point - (MaxTrades-OpenOrders)*Pips*Point, Digits); }
		    else { sl=BuyPrice-InitialStop*Point; }
		    if (OpenOrders!=0) {
			   mylotsi=lotsi;			
			   for(cnt=1;cnt<=OpenOrders;cnt++)
			   {
				  if (MaxTrades>12) { mylotsi=NormalizeDouble(mylotsi*1.5,2); }
				  else { mylotsi=NormalizeDouble(mylotsi*2,2); }
			   }
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    OrderSend(Symbol(),OP_BUY,mylotsi,BuyPrice,slippage,sl,tp,"10Points3 Short Order",Magic,0,Blue);		   
		    return(0);
	     }
	     ////if(Use_time_interval){Sleep(SleepTime);}
      }   

//----
   return(0);
  }
//+------------------------------------------------------------------+

//determines current direction, will need to add more intelligence to this
//this determines if the 10poitns3 can go to work in a direction
//may possible be multiple criteria for same entry direction, if there is they will need multiple criteria for close direction
int entryDirection() 
{
	
	if(iRSI(NULL,0,21,PRICE_CLOSE,0)>50 && iRSI(NULL,0,21,PRICE_CLOSE,0)>iRSI(NULL,0,21,PRICE_CLOSE,1)) { return(2); }
	//if (iRSI(NULL,0,21,PRICE_CLOSE,2)<50 && iRSI(NULL,0,21,PRICE_CLOSE,1)>50 && iRSI(NULL,0,21,PRICE_CLOSE,0)>iRSI(NULL,0,21,PRICE_CLOSE,1)) { return(2); }
	////if (iRSI(NULL,0,21,PRICE_CLOSE,2)<60 && iRSI(NULL,0,21,PRICE_CLOSE,1)>60 && iRSI(NULL,0,21,PRICE_CLOSE,0)>iRSI(NULL,0,21,PRICE_CLOSE,1)){ return(2); }
	
	if(iRSI(NULL,0,21,PRICE_CLOSE,0)<50 && iRSI(NULL,0,21,PRICE_CLOSE,0)<iRSI(NULL,0,21,PRICE_CLOSE,1)) { return(1); }
	//if (iRSI(NULL,0,21,PRICE_CLOSE,2)>50 && iRSI(NULL,0,21,PRICE_CLOSE,1)<50 && iRSI(NULL,0,21,PRICE_CLOSE,0)<iRSI(NULL,0,21,PRICE_CLOSE,1)) { return(1); }
	////if (iRSI(NULL,0,21,PRICE_CLOSE,2)>40 && iRSI(NULL,0,21,PRICE_CLOSE,1)<40 && iRSI(NULL,0,21,PRICE_CLOSE,0)<iRSI(NULL,0,21,PRICE_CLOSE,1)) { return(1); }
	
	else {return(3);}//no criteria satisfied
}

//checks if direction is going opposite of original entry direction
int auditTrade() 
{
	if(iRSI(NULL,0,21,PRICE_CLOSE,0)>51) { return(2); }
	if(iRSI(NULL,0,21,PRICE_CLOSE,0)<49) { return(1); }
	//if (iRSI(NULL,0,21,PRICE_CLOSE,2)<55 && iRSI(NULL,0,21,PRICE_CLOSE,1)>55 && iRSI(NULL,0,21,PRICE_CLOSE,0)>iRSI(NULL,0,21,PRICE_CLOSE,1)){ return(2); }
	//if (iRSI(NULL,0,21,PRICE_CLOSE,2)>45 && iRSI(NULL,0,21,PRICE_CLOSE,1)<45 && iRSI(NULL,0,21,PRICE_CLOSE,0)<iRSI(NULL,0,21,PRICE_CLOSE,1)) { return(1); }
	else {return(3);}//no criteria satisfied
}